//+------------------------------------------------------------------+
//|                                             Keltner Channels.mq4 |
//|                                                  Coded by Gilani |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Cyan
#property indicator_color2 Red
#property indicator_style1 14
#property indicator_style2 2


extern int TimeFrame=0;
extern int MAPeriod=3;
extern int ma_shift=-2;  //Cyan bottom Dn
extern int ma_method=3;    // 3 Linear weighted moving average
extern int applied_price=1;//1 Open price. 
extern int MAPeriod1=3;
extern int ma_shift1=2; //Red bottom up
extern int ma_method1=3;   // 3 Linear weighted moving average
extern int applied_price1=1; //1 Open price. 

extern bool   alertsOn          = false;
extern bool   alertsOnCurrent   = False;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = True;
extern bool   alertsEmail       = false;

extern bool   ShowArrows       = true;
extern string ArrowsIdentifier = "RK-DualMA";
extern color  ArrowUpColor     = Cyan; //Green;
extern color  ArrowDownColor   = Yellow; //Crimson; //Red;

double trend[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
datetime prevtime = 0;

int init()
  {
   string short_name;
   string short_name1;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE); //,STYLE_DOT,1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1);
   
   if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0,ma_shift*TimeFrame/Period());
   SetIndexShift(1,ma_shift1*TimeFrame/Period());

   SetIndexBuffer(2,trend);
    
   SetIndexLabel(0,"Dual-Cyan-EMB1");
   SetIndexLabel(1,"Dual-Red-EMB2");     
   SetIndexLabel(2,"Dual-trd("+MAPeriod+") - "+DoubleToStr(MAPeriod1,2)+")");

    switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName (short_name+MAPeriod+") "+TimeFrameStr);  
 

return(0);
}

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
  }
return(0);
}
/*int start() {                 This is the keltner channel indicator & I'm trying to duplicate it in this Indicator
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double avg;
   for(int x=limit; x>=0; x--)
   //for(int x=0; x<limit; x++) 
   {
      middle[x] = iMA(NULL, 0, period, 0, KCMode, PRICE_CLOSE, x);
      avg  = findAvg(period, x);
      upper[x] = middle[x] + (avg*NumATRs);
      lower[x] = middle[x] - (avg*NumATRs);
      trend[x] = trend[x+1];
       if (Close[x] >= upper[x])  trend[x] =  1;
       if (Close[x] <= lower[x])  trend[x] = -1;   
       if (Close[x] <= upper[x] && Close[x] >= lower[x])  trend[x] = 0;  
      manageArrow(x);
   }
*/

// I'm trying to get a trend 1 when the EMB1 crosses over the EMB2 && the candle fits in between the two.


int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double avg;
   for(int x=limit; x>=0; x--)
   //for(int x=0; x<limit; x++) 
   {
      ExtMapBuffer1[x]=iMA(NULL,TimeFrame,MAPeriod,ma_shift,ma_method, applied_price,x) ;//Cyan top up
      ExtMapBuffer2[x]=iMA(NULL,TimeFrame,MAPeriod1,ma_shift1,ma_method1,applied_price1,x) ;//Red top Dwn
      
      trend[x] = trend[x+1];
      // if (ExtMapBuffer1[x]> ExtMapBuffer2[x] && ExtMapBuffer2[x] < Open[x] && ExtMapBuffer1[x] > Close[x]) trend[x] =  1;
       //if (ExtMapBuffer1[x]< ExtMapBuffer2[x] && ExtMapBuffer2[x] > Open[x] && ExtMapBuffer1[x] < Close[x]) trend[x] = -1;   
       
       if (ExtMapBuffer1[x]> ExtMapBuffer2[x] && Close[x] > Open[x] && Open[x] > ExtMapBuffer2[x] && Close[x] < ExtMapBuffer1[x]) trend[x] =  1;
       if (ExtMapBuffer1[x]< ExtMapBuffer2[x] && Close[x] < Open[x] && Open[x] < ExtMapBuffer2[x] && Close[x] > ExtMapBuffer1[x]) trend[x] = -1;   
       
       //if (trend[1] == 1  && Close[x] > ExtMapBuffer1[x])  trend[x] = 0;   
       //if (trend[1] == -1 && Close[x] < ExtMapBuffer1[x])  trend[x] = 0;      
       //else 
      //trend[x] = 0;
       
      manageArrow(x);
   }
   
   manageAlerts();  
   return(0);
  }
//+------------------------------------------------------------------+
   
 void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //if ((Close [whichBar]>= lower[whichBar]) && (Close[whichBar] <= upper[whichBar])) //{ prevtime = 0;
       
      if (ExtMapBuffer2[whichBar]>= ExtMapBuffer1[whichBar] && ExtMapBuffer2[whichBar] > Close[whichBar] && ExtMapBuffer1[whichBar] <= Open[whichBar] 
      && (prevtime != Time[0]))doAlert(whichBar,"up"  ,1);
      if (ExtMapBuffer1[whichBar]>= ExtMapBuffer2[whichBar] && ExtMapBuffer2[whichBar] < Close[whichBar] && ExtMapBuffer1[whichBar] >= Open[whichBar]
      && (prevtime != Time[0]))doAlert(whichBar,"down",-1);
      
      //if ((Close[whichBar] > upper[whichBar]) && (prevtime != Time[0]))doAlert(whichBar,"up"  ,1);
      //if (trendsBuffer[whichBar] ==  1) doAlert(whichBar,"up"  ,valuesBuffer[whichBar]);
     // if (trendsBuffer[whichBar] == -1) doAlert(whichBar,"down",valuesBuffer[whichBar]);
     // if ((Close[whichBar] < lower[whichBar]) && (prevtime != Time[0]))doAlert(whichBar,"down",-1);
   
   }
}
void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," tf-",(Period())," at ",
       TimeToStr(TimeLocal(),TIME_SECONDS)," RK-KC Alert "+"  Bid -"+DoubleToStr(Bid,Digits)+"  Ask -"+DoubleToStr(Ask,Digits)+"  "
       +DoubleToStr(value,2)+" KC Breakout-",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Keltner breakout "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

void manageArrow(int x)
{
   if (ShowArrows)
   {
      double dist = iATR(NULL,0,20,x)/1.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      if (trend[x] != trend[x+1])
         {
            string name = ArrowsIdentifier+Time[x];
            if (trend[x] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],Low[x]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,241);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
            }
            else
            if (trend[x] == -1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],High[x]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,242);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
            }
         }
   }
}

